<template>
  <div class="deposit_block">
    <div class="container-plain">
      <div class="deposit_block-title">{{$t('deposit.anyCrypto')}}</div>
      <div class="deposit_block-promo">
        <div class="deposit_block-promo-img-wrapper">
          <img
            class="deposit_block-promo-img"
            src="~/static/deposit/Eos-Logo.png"
            alt=""></div>
        <div class="deposit_block-promo-img-wrapper">
          <img
            class="deposit_block-promo-img"
            src="~/static/deposit/Bitcoin-Logo.png"
            alt=""></div>
        <div class="deposit_block-promo-img-wrapper">
          <img
            class="deposit_block-promo-img"
            src="~/static/deposit/Ethereum-Logo.png"
            alt=""></div>
        <div class="deposit_block-promo-img-wrapper">
          <img
            class="deposit_block-promo-img"
            src="~/static/deposit/Bincane-Logo.png"
            alt=""></div>
        <div class="deposit_block-promo-img-wrapper">
          <img
            class="deposit_block-promo-img"
            src="~/static/deposit/Ripple-Logo1.png"
            alt=""></div>
        <div class="deposit_block-promo-img-wrapper">
          <img
            class="deposit_block-promo-img"
            src="~/static/deposit/BCash-Logo.png"
            alt=""></div>
        <div class="deposit_block-promo-img-wrapper">
          <img
            class="deposit_block-promo-img"
            src="~/static/deposit/Litecoin-Logo.png"
            alt=""></div>
        <div class="deposit_block-promo-img-wrapper">
          <img
            class="deposit_block-promo-img"
            src="~/static/deposit/Monero-Logo.png"
            alt=""></div>
        <div class="deposit_block-promo-img-wrapper">
          <img
            class="deposit_block-promo-img"
            src="~/static/deposit/Dash-Logo.png"
            alt=""></div>
        <div class="deposit_block-promo-img-wrapper">
          <img
            class="deposit_block-promo-img"
            src="~/static/deposit/Tether-Logo.png"
            alt=""></div>
        <div class="deposit_block-promo-last">
          + 1500
        </div>
      </div>
      <div class="deposit_block-media">
        <div class="deposit_block-media-inner">
          <img
            class="deposit_block-media-res"
            src="~/static/deposit/Vid.png"
            alt="">
        </div>
      </div>
      <div class="deposit_block-form">
        <div class="deposit_block-form-item">
          <span class="deposit_block-form-title"><span class="required">*</span>Select currency you will pay</span>
          <BSelect
            class="select"
            v-model="currency"
            label="ticker"
            clearable
            :searchable="false"
            :options="currentyList"></BSelect>
        </div>
        <div class="deposit_block-form-item" v-show="currency.ticker!=='usd'">
          <span class="deposit_block-form-title"><span class="required">*</span>Enter amount you will pay</span>
          <BInput
            type="number"
            v-model="amount"
            label="Enter amount to pay"></BInput>
        </div>
        <div class="deposit_block-form-item" v-show="currency.ticker!=='usd'">
          <span class="deposit_block-form-title"><span class="required">*</span>Enter email for notice</span>
          <BInput
            v-model="email"
            label="Enter email"></BInput>
        </div>
        <div
          class="deposit_block-form-item"
          v-if="estimated">
          You will get {{estimated}}
        </div>
      </div>
      <div
        class="flex flex-center"
        v-if="!info.payinAddress">
        <a
          v-if="currency.ticker==='usd'"
          target="_blank"
          :href="fiatLink">
          <Btn
            big>{{$t('deposit.deposit')}}
          </Btn>
        </a>
        <Btn
          big
          v-else
          @click="submit">{{$t('deposit.deposit')}}
        </Btn>
      </div>
      <div
        class="deposit_block-form-item"
        v-else>
        <div class="deposit_block-form-info">
          <div>Send {{amount}} {{info.fromCurrency}} to address</div>
          <div class="flex pt-10 pb-10">
            <img
              @click="copy(info.payinAddress)"
              src="~/static/icons/copy.png"
              class="icon pr-10"
              alt="">
            <div class="text-ellipsis">{{info.payinAddress}}</div>
          </div>
          <div>for getting {{info.amount}} {{info.toCurrency}}</div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import Btn from '~/components/UI/BtnSign';
  import BInput from './Input';
  import BSelect from 'vue-select';
  import notification
    from '~/components/UI/Notification/main.js';
  import MobileDetect from 'mobile-detect';
  import debounce from 'lodash.debounce';
  import copyClipboard from '~/components/utils/copy';

  export default {
    name: "TheAnyCrypto",
    data() {
      return {
        amount: '',
        email: '',
        currency: {
          ticker: 'btc'
        },
        estimated: '',
        onInput: () => {
        },
        info: {}
      }
    },
    components: {
      Btn,
      BInput,
      BSelect
    },
    computed: {
      fiatLink() {
        return `https://changenow.io/exchange?amount=${this.amount}&from=usd&link_id=4b0a58f409dd87&to=eos`;
      },
      accountName() {
        return this.$store.state.wallet.accountName;
      },
      currentyList() {
        return this.$store.state.deposit.data;
      }
    },
    methods: {
      submit() {
        const md = new MobileDetect(navigator.userAgent);

        if (!this.amount) return notification.warning({
          message: 'Amount is empty'
        });

        if (!this.currency.ticker) return notification.warning({
          message: 'Currency is empty'
        });

        const validEmail = this.email.match(/(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:(2(5[0-5]|[0-4][0-9])|1[0-9][0-9]|[1-9]?[0-9]))\.){3}(?:(2(5[0-5]|[0-4][0-9])|1[0-9][0-9]|[1-9]?[0-9])|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])/gi);
        if (!validEmail) return notification.warning({
          message: 'Enter valid email'
        });
        this.$store.dispatch('deposit/send', {
          username: localStorage.getItem('accountname'),
          address: localStorage.getItem('accountname'),
          amount: this.amount,
          currency: this.currency.ticker,
          email: this.email
        }).then(res => {
          this.info = res;
        }).catch(e => {
          return notification.error({
            message: 'Error creating invoice - ' + e,
          });
        });
      },
      copy(text = '') {
        copyClipboard(text, this.$t('common.copy'));
      },
      getEstimated() {
        this.$store.dispatch('deposit/estimated', {
          from: this.currency.ticker,
          amount: this.amount || 0
        }).then(res => {
          this.estimated = res + ' EOS';
        }).catch(e => {
          this.estimated = e.message;
        });
      }
    },
    watch: {
      'amount': function () {
        this.info = {};
        this.onInput();
      }
    },
    mounted() {
      this.onInput = debounce(this.getEstimated, 800);
    }
  }
</script>
